# ナップサックの容量
C = 5

# 品物の価値と重量（v[i]とw[i]はそれぞれ品物iの価値と重量を表す）
v = [2, 4, 3]
w = [2, 2, 3]

# 品物の種類数
n = len(v)

# 空き容量cのナップサックに
# 品物iから品物n-1を入れる場合の最大価値を算出する関数
def knapsack(i, c):

    # ③問題の解が自明な場合は再帰呼び出しを行わないようにする
    if i >= n:
        # i>=nの品物iは存在しない
        return 0

    if c < w[i]:
        # 品物iはナップサックに入らない

        # ①問題を一段階簡単にした上で再帰呼び出しを行う
        # 品物iをナップサックに入れない場合の最大価値を取得
        no_put_value = knapsack(i + 1, c)

        # ②再帰呼び出しの結果を利用して問題を一段階だけ解く
        # 品物iはナップサックに入らないので入れる場合の価値は考慮不要
        max_value = no_put_value
    else:
        # ①問題を一段階簡単にした上で再帰呼び出しを行う
        # 品物iをナップサックに入れない場合の最大価値を取得
        no_put_value = knapsack(i + 1, c)

        # 品物iをナップサックに入れる場合の最大価値を取得
        put_value = knapsack(i + 1, c - w[i])

        # ②再帰呼び出しの結果を利用して問題を一段階だけ解く
        # 品物iを入れる場合と入れない場合との大きい方の価値を取得
        max_value = max(no_put_value, put_value + v[i])

    # 大きい方の価値を返却
    return max_value

def main():
    max_value = knapsack(0, C)
    print(max_value)

if __name__ == '__main__':
    main()