# 迷路の定義
map = [
    ['o','o','o','o','o','x','o','x','o','o','o','x','o','o','o','o'],
    ['o','x','o','x','x','x','o','x','o','x','o','x','o','x','o','x'],
    ['o','x','o','o','o','o','o','x','o','x','o','o','o','x','o','o'],
    ['o','o','x','x','o','x','x','x','o','x','x','x','x','x','x','o'],
    ['x','o','x','x','o','x','o','o','o','o','o','x','o','x','o','o'],
    ['o','o','o','x','o','x','x','x','o','x','x','o','x','o','o','x'],
    ['x','o','x','x','o','x','o','x','o','x','x','o','x','o','x','x'],
    ['o','o','o','o','o','o','o','o','o','x','o','x','x','o','o','G'],
]

WIDTH = len(map[0])
HEIGHT = len(map)

def maze(start, map):
    i, j = start
    # ③問題の解が自明な場合は再帰呼び出しを行わないようにする
    if i < 0 or i >= WIDTH or j < 0 or j >= HEIGHT:
        # 現在位置は迷路外である
        return False
    if map[j][i] == 'p':
        # 現在位置は既に通過している
        return False
    if map[j][i] == 'x':
        # 現在位置は壁である
        return False
    if map[j][i] == 'G':
        # 現在位置はゴールである！
        return True

    # ①問題を一段階簡単にした上で再帰呼び出しを行う
    # 現在位置を既に通過済みとして問題を一段階簡単にする
    map[j][i] = 'p'

    # 現在位置の上下左右の位置をスタートとしてゴールに到達可能かを調べる
    is_goaled_left = maze((i - 1, j), map)
    is_goaled_right = maze((i + 1, j), map)
    is_goaled_up = maze((i, j - 1), map)
    is_goaled_down = maze((i, j + 1), map)

    # ②再帰呼び出しの結果を利用して問題を一段階だけ解く
    if is_goaled_left or is_goaled_right or is_goaled_up or is_goaled_down:
        # 一方向でもゴールに到達可能なら、現在位置からもゴールに到達可能
        is_goaled = True
    else:
        # 全方向でゴールに到達不可なら、現在位置からもゴールに到達不可
        is_goaled = False

    return is_goaled

def main():
    start = (8, 4)
    isGoal = maze(start, map)
    if isGoal:
        print('ゴールに到達可能です')
    else:
        print('ゴールには到達できません')

if __name__ == '__main__':
    main()
