# 第1引数で与えられた数のリスト内の数値を何個か使った際の和 (ただし第2引数で指定した値以下) を求める
def find_max_dp(num_list, limit):
    list_len = len(num_list)
    dp_table = [[0 for j in range(limit + 1)] for i in range(list_len)]

    # リスト内の1番目の値の考慮 (表でいう1行目)
    for j in range(limit + 1):
        if num_list[0] <= j:
            dp_table[0][j] = num_list[0] # 1番目のカードを追加

    # リスト内の2番目以降の値を考慮 (表でいう2行目以降)
    for i in range(list_len):
        for j in range(limit + 1):
            tmp_not_choice = dp_table[i-1][j]
            if num_list[i] > j: # 上限値オーバーのとき
                dp_table[i][j] = tmp_not_choice # 1つ前の値をそのまま追加
            else:
                tmp_choice = dp_table[i-1][j - num_list[i]] + num_list[i]
                # 追加しない場合 or 追加する場合を比べ、より大きい方を選択
                dp_table[i][j] = max(tmp_choice,tmp_not_choice)

    return dp_table[list_len - 1][limit]

num_list = [3,5,7]
limit = 10
list_total_with_limit = find_max_dp(num_list,limit)

# 最大値が limit と等しければ部分和問題の答えはYesとなる。
if limit == list_total_with_limit:
    print("Yes")
else:
    print("No")
